import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.List;
/**
 * Write a description of class Player here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Player extends Actor {
    /**
     * Act - do whatever the Player wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    GreenfootImage basic = new GreenfootImage(20,20);
    
    List<Ground> allGround;
    List<BackGround> allBackGround;
    List<BackGround> neabyBackGround;
    List<Ground> nearbyGround;
    Ground groundBelowPlayer;
    
    List<Ground> belowPlayerLeft;
    List<Ground> belowPlayerMiddle;
    List<Ground> belowPlayerRight;
    
    List<Ground> abovePlayerLeft;
    List<Ground> abovePlayer;
    List<Ground> abovePlayerRight;
    
    boolean areFalling = false;
    boolean groundSettled = false;
    boolean groundShifted = false;
    boolean playerSettled = false;
    
    double gravity = 0;
    int gravCount = 0;
    double MAX_gravity = 10;
    double MIN_gravity = -4;
    boolean gravitySet = false;
    
    int digCount = 0;
    int digSpeed = 25;
    
    public Player() {
        basic.setColor(Color.BLUE);
        basic.fill();
        setImage(basic);
    }
    
    protected void addedToWorld(World world) {
        allGround = getWorld().getObjects(Ground.class);
        allBackGround = getWorld().getObjects(BackGround.class);
    }
    
    public void act() {
        belowPlayerLeft = getObjectsAtOffset(-8,10,Ground.class);//get Objects 1 pixel below the player's left corner(1px in from the side)
        belowPlayerMiddle = getObjectsAtOffset(0,10,Ground.class);//get Objects 1 pixel below the player
        belowPlayerRight = getObjectsAtOffset(7,10,Ground.class);//get Objects 1 pixel below the player's right corner(1px in from the side)
        
        abovePlayerLeft = getObjectsAtOffset(-8,-10,Ground.class);//get Objects 1 px above the player's left corner(1px in from the side)
        abovePlayer = getObjectsAtOffset(0,-11,Ground.class);//get objects 1 px above the player
        abovePlayerRight = getObjectsAtOffset(7,-10,Ground.class);//get objects 1 px above the player's right corner(1px in from the side)
        
        nearbyGround = getObjectsInRange(250,Ground.class);
        neabyBackGround = getObjectsInRange(150,BackGround.class);
        
        updateNearbyGroundFog();
        
        if(belowPlayerLeft.size() == 0 && belowPlayerRight.size() == 0 && belowPlayerMiddle.size() == 0) {
            groundSettled = false;
            groundBelowPlayer = null;
            gravitySet = false;
            digCount = 0;
            if(!Greenfoot.isKeyDown("w")) {
                if(gravity < MAX_gravity)
                    gravity += .2;
                if(gravity > 0)
                    areFalling = true;
                if(gravity < 0) {
                    if(abovePlayer.size() != 0)
                        gravity = 0;
                }
                for(Ground all : allGround)
                    all.setLocation(all.getX(),all.getY() - (int)gravity);
                for(BackGround allBG : allBackGround)
                    allBG.setLocation(allBG.getX(),allBG.getY() - (int)gravity);
            }
        } else if(belowPlayerMiddle.size() > 0) {
            groundBelowPlayer = belowPlayerMiddle.get(0);
            if(gravitySet == false) {
                gravity = 0;
                gravitySet = true;
            }
            areFalling = false;
            if(groundSettled == false) {
                int distance = ((groundBelowPlayer.getY() - getY()) - 23);
                for(Ground all : allGround)
                    all.setLocation(all.getX(),all.getY() - distance);
                for(BackGround allBG : allBackGround)
                    allBG.setLocation(allBG.getX(),allBG.getY() - distance);
                groundSettled = true;
            }
        }

        if(Greenfoot.isKeyDown("d") && !Greenfoot.isKeyDown("s")) {
            groundShifted = false;
            List<Ground> right = getObjectsAtOffset(10,0,Ground.class);
            if(right.size() == 0) {
                if(belowPlayerLeft.size() == 0 && Greenfoot.isKeyDown("shift")) {
                    //do nothing and fall down hole
                } else {
                    for(Ground all : allGround)
                        all.setLocation(all.getX() - 2,all.getY());
                    for(BackGround allBG : allBackGround)
                        allBG.setLocation(allBG.getX() - 2,allBG.getY());
                }
                digCount = 0;
            } else {
                if(!areFalling) {
                    digCount++;
                    if(digCount == digSpeed) {
                        getWorld().removeObjects(right);
                        allGround = getWorld().getObjects(Ground.class);
                        digCount = 0;
                    }
                }
            }
        }

        if(Greenfoot.isKeyDown("a") && !Greenfoot.isKeyDown("s")) {
            groundShifted = false;
            List<Ground> left = getObjectsAtOffset(-10,0,Ground.class);
            if(left.size() == 0) {
                if(belowPlayerRight.size() == 0 && Greenfoot.isKeyDown("shift")) {
                    //do nothing and fall down hole
                } else {
                    for(Ground all : allGround)
                        all.setLocation(all.getX() + 2,all.getY());
                    for(BackGround allBG : allBackGround)
                        allBG.setLocation(allBG.getX() + 2,allBG.getY());
                }
                digCount = 0;
            } else if(!areFalling) {
                digCount++;
                if(digCount == digSpeed) {
                    getWorld().removeObjects(left);
                    allGround = getWorld().getObjects(Ground.class);
                    digCount = 0;
                }
            }
        }

        if(Greenfoot.isKeyDown("s")) {
            if(groundBelowPlayer != null) {
                if(groundShifted == false) {
                    int distance = getX() - groundBelowPlayer.getX();
                    for(Ground all : allGround)
                        all.setLocation(all.getX() + distance, all.getY());
                    for(BackGround allBG : allBackGround)
                        allBG.setLocation(allBG.getX() + distance, allBG.getY());
                    groundShifted = true;
                }
                digCount++;
                if(digCount == digSpeed) {
                    getWorld().removeObject(groundBelowPlayer);
                    allGround = getWorld().getObjects(Ground.class);
                    digCount = 0;
                }
            }
        }

        if(Greenfoot.isKeyDown("w")) {
            areFalling = false;
            if(abovePlayer.size() == 0 && abovePlayerLeft.size() == 0 && abovePlayerRight.size() == 0) {
                groundSettled = false;
                groundBelowPlayer = null;
                digCount = 0;
                if(gravity > MIN_gravity)
                    gravity -= .2;
                for(Ground all : allGround)
                    all.setLocation(all.getX(),all.getY() - (int)gravity);
                for(BackGround allBG : allBackGround)
                    allBG.setLocation(allBG.getX(),allBG.getY() - (int)gravity);
            } else {
                gravity = 0;
            }
            getWorld().addObject(new Smoke(90),getX() + (Greenfoot.getRandomNumber(10) - 5),getY()+12);
        }
    }    
    
    private void updateNearbyGroundFog() {
        for(Ground change : nearbyGround) {
            int dx = getX() - change.getX();
            int dy = getY() - change.getY();
            int distance = (int)Math.sqrt(dx*dx + dy*dy);
            if(distance > 225) {
                change.updateImage(225);
            } else {
                change.updateImage(distance);
            }
        }
        for(BackGround change : neabyBackGround) {
            int dx = getX() - change.getX();
            int dy = getY() - change.getY();
            int distance = (int)Math.sqrt(dx*dx + dy*dy);
            if(distance > 100) {
                change.updateImage(107);
            } else {
                change.updateImage(distance);
            }
        }
    }
}
